// Class: format.png.Tools

var $global = typeof window != "undefined" ? window : typeof global != "undefined" ? global : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = require("./../../hxClasses_stub").default;
var $import = require("./../../import_stub").default;
function Type() {return require("./../../Type");}
function js__$Boot_HaxeError() {return require("./../../js/_Boot/HaxeError");}
function haxe_io_Bytes() {return require("./../../haxe/io/Bytes");}
function haxe_io_BytesBuffer() {return require("./../../haxe/io/BytesBuffer");}
function format_tools_Inflate() {return require("./../../format/tools/Inflate");}
function List() {return require("./../../List");}
function format_png_Chunk() {return require("./../../format/png/Chunk");}
function format_png_Color() {return require("./../../format/png/Color");}
function format_tools_Deflate() {return require("./../../format/tools/Deflate");}

// Constructor

var Tools = function(){}

// Meta

Tools.__name__ = ["format","png","Tools"];
Tools.prototype = {
	
};
Tools.prototype.__class__ = Tools.prototype.constructor = $hxClasses["format.png.Tools"] = Tools;

// Init



// Statics

Tools.getHeader = function(d) {
	var c = d.iterator();
	while(c.hasNext()) {
		var c1 = c.next();
		if((Type().default).enumIndex(c1) == 1) {
			var h = c1[2];
			return h;
		}
	}
	throw new (js__$Boot_HaxeError().default)("Header not found");
}
Tools.getPalette = function(d) {
	var c = d.iterator();
	while(c.hasNext()) {
		var c1 = c.next();
		if((Type().default).enumIndex(c1) == 3) {
			var b = c1[2];
			return b;
		}
	}
	return null;
}
Tools.filter = function(data,x,y,stride,prev,p,numChannels) {
	if(numChannels == null) {
		numChannels = 4;
	}
	var b = y == 0 ? 0 : data.get(p - stride);
	var c = x == 0 || y == 0 ? 0 : data.get(p - stride - numChannels);
	var k = prev + b - c;
	var pa = k - prev;
	if(pa < 0) {
		pa = -pa;
	}
	var pb = k - b;
	if(pb < 0) {
		pb = -pb;
	}
	var pc = k - c;
	if(pc < 0) {
		pc = -pc;
	}
	if(pa <= pb && pa <= pc) {
		return prev;
	} else if(pb <= pc) {
		return b;
	} else {
		return c;
	}
}
Tools.reverseBytes = function(b) {
	var p = 0;
	var _g1 = 0;
	var _g = b.get_length() >> 2;
	while(_g1 < _g) {
		var i = _g1++;
		var b1 = b.get(p);
		var g = b.get(p + 1);
		var r = b.get(p + 2);
		var a = b.get(p + 3);
		b.set(p++,a);
		b.set(p++,r);
		b.set(p++,g);
		b.set(p++,b1);
	}
}
Tools.extractGrey = function(d) {
	var h = Tools.getHeader(d);
	var grey = (haxe_io_Bytes().default).alloc(h.width * h.height);
	var data = null;
	var fullData = null;
	var c = d.iterator();
	while(c.hasNext()) {
		var c1 = c.next();
		if((Type().default).enumIndex(c1) == 2) {
			var b = c1[2];
			if(fullData != null) {
				fullData.add(b);
			} else if(data == null) {
				data = b;
			} else {
				fullData = new (haxe_io_BytesBuffer().default)();
				fullData.add(data);
				fullData.add(b);
				data = null;
			}
		}
	}
	if(fullData != null) {
		data = fullData.getBytes();
	}
	if(data == null) {
		throw new (js__$Boot_HaxeError().default)("Data not found");
	}
	data = (format_tools_Inflate().default).run(data);
	var r = 0;
	var w = 0;
	var _g = h.color;
	if((Type().default).enumIndex(_g) == 0) {
		var alpha = _g[2];
		if(h.colbits != 8) {
			throw new (js__$Boot_HaxeError().default)("Unsupported color mode");
		}
		var width = h.width;
		var stride = (alpha ? 2 : 1) * width + 1;
		if(data.get_length() < h.height * stride) {
			throw new (js__$Boot_HaxeError().default)("Not enough data");
		}
		var rinc = alpha ? 2 : 1;
		var _g1 = 0;
		var _g2 = h.height;
		while(_g1 < _g2) {
			var y = _g1++;
			var f = data.get(r++);
			switch(f) {
			case 0:
				var _g3 = 0;
				var _g21 = width;
				while(_g3 < _g21) {
					var x = _g3++;
					var v = data.get(r);
					r += rinc;
					grey.set(w++,v);
				}
				break;
			case 1:
				var cv = 0;
				var _g31 = 0;
				var _g22 = width;
				while(_g31 < _g22) {
					var x1 = _g31++;
					cv += data.get(r);
					r += rinc;
					grey.set(w++,cv);
				}
				break;
			case 2:
				var stride1 = y == 0 ? 0 : width;
				var _g32 = 0;
				var _g23 = width;
				while(_g32 < _g23) {
					var x2 = _g32++;
					var v1 = data.get(r) + grey.get(w - stride1);
					r += rinc;
					grey.set(w++,v1);
				}
				break;
			case 3:
				var cv1 = 0;
				var stride2 = y == 0 ? 0 : width;
				var _g33 = 0;
				var _g24 = width;
				while(_g33 < _g24) {
					var x3 = _g33++;
					cv1 = data.get(r) + (cv1 + grey.get(w - stride2) >> 1) & 255;
					r += rinc;
					grey.set(w++,cv1);
				}
				break;
			case 4:
				var stride3 = width;
				var cv2 = 0;
				var _g34 = 0;
				var _g25 = width;
				while(_g34 < _g25) {
					var x4 = _g34++;
					cv2 = Tools.filter(grey,x4,y,stride3,cv2,w,1) + data.get(r) & 255;
					r += rinc;
					grey.set(w++,cv2);
				}
				break;
			default:
				throw new (js__$Boot_HaxeError().default)("Invalid filter " + f);
			}
		}
	} else {
		throw new (js__$Boot_HaxeError().default)("Unsupported color mode");
	}
	return grey;
}
Tools.extract32 = function(d,bytes,flipY) {
	var h = Tools.getHeader(d);
	var bgra = bytes == null ? (haxe_io_Bytes().default).alloc(h.width * h.height * 4) : bytes;
	var data = null;
	var fullData = null;
	var c = d.iterator();
	while(c.hasNext()) {
		var c1 = c.next();
		if((Type().default).enumIndex(c1) == 2) {
			var b = c1[2];
			if(fullData != null) {
				fullData.add(b);
			} else if(data == null) {
				data = b;
			} else {
				fullData = new (haxe_io_BytesBuffer().default)();
				fullData.add(data);
				fullData.add(b);
				data = null;
			}
		}
	}
	if(fullData != null) {
		data = fullData.getBytes();
	}
	if(data == null) {
		throw new (js__$Boot_HaxeError().default)("Data not found");
	}
	data = (format_tools_Inflate().default).run(data);
	var r = 0;
	var w = 0;
	var lineDelta = 0;
	if(flipY) {
		lineDelta = -h.width * 8;
		w = (h.height - 1) * (h.width * 4);
	}
	var flipY1 = flipY ? -1 : 1;
	var _g = h.color;
	switch((Type().default).enumIndex(_g)) {
	case 0:
		var alpha = _g[2];
		if(h.colbits != 8) {
			throw new (js__$Boot_HaxeError().default)("Unsupported color mode");
		}
		var width = h.width;
		var stride = (alpha ? 2 : 1) * width + 1;
		if(data.get_length() < h.height * stride) {
			throw new (js__$Boot_HaxeError().default)("Not enough data");
		}
		var alphvaIdx = -1;
		if(!alpha) {
			var t = d.iterator();
			while(t.hasNext()) {
				var t1 = t.next();
				if((Type().default).enumIndex(t1) == 4) {
					if(t1[2] == "tRNS") {
						var data1 = t1[3];
						if(data1.get_length() >= 2) {
							alphvaIdx = data1.get(1);
						}
						break;
					}
				}
			}
		}
		var _g1 = 0;
		var _g2 = h.height;
		while(_g1 < _g2) {
			var y = _g1++;
			var f = data.get(r++);
			switch(f) {
			case 0:
				if(alpha) {
					var _g3 = 0;
					var _g21 = width;
					while(_g3 < _g21) {
						var x = _g3++;
						var v = data.get(r++);
						bgra.set(w++,v);
						bgra.set(w++,v);
						bgra.set(w++,v);
						bgra.set(w++,data.get(r++));
					}
				} else {
					var _g31 = 0;
					var _g22 = width;
					while(_g31 < _g22) {
						var x1 = _g31++;
						var v1 = data.get(r++);
						bgra.set(w++,v1);
						bgra.set(w++,v1);
						bgra.set(w++,v1);
						bgra.set(w++,v1 == alphvaIdx ? 0 : 255);
					}
				}
				break;
			case 1:
				var cv = 0;
				var ca = 0;
				if(alpha) {
					var _g32 = 0;
					var _g23 = width;
					while(_g32 < _g23) {
						var x2 = _g32++;
						cv += data.get(r++);
						bgra.set(w++,cv);
						bgra.set(w++,cv);
						bgra.set(w++,cv);
						ca += data.get(r++);
						bgra.set(w++,ca);
					}
				} else {
					var _g33 = 0;
					var _g24 = width;
					while(_g33 < _g24) {
						var x3 = _g33++;
						cv += data.get(r++);
						bgra.set(w++,cv);
						bgra.set(w++,cv);
						bgra.set(w++,cv);
						bgra.set(w++,cv == alphvaIdx ? 0 : 255);
					}
				}
				break;
			case 2:
				var stride1 = y == 0 ? 0 : width * 4 * flipY1;
				if(alpha) {
					var _g34 = 0;
					var _g25 = width;
					while(_g34 < _g25) {
						var x4 = _g34++;
						var v2 = data.get(r++) + bgra.get(w - stride1);
						bgra.set(w++,v2);
						bgra.set(w++,v2);
						bgra.set(w++,v2);
						bgra.set(w++,data.get(r++) + bgra.get(w - stride1));
					}
				} else {
					var _g35 = 0;
					var _g26 = width;
					while(_g35 < _g26) {
						var x5 = _g35++;
						var v3 = data.get(r++) + bgra.get(w - stride1);
						bgra.set(w++,v3);
						bgra.set(w++,v3);
						bgra.set(w++,v3);
						bgra.set(w++,v3 == alphvaIdx ? 0 : 255);
					}
				}
				break;
			case 3:
				var cv1 = 0;
				var ca1 = 0;
				var stride2 = y == 0 ? 0 : width * 4 * flipY1;
				if(alpha) {
					var _g36 = 0;
					var _g27 = width;
					while(_g36 < _g27) {
						var x6 = _g36++;
						cv1 = data.get(r++) + (cv1 + bgra.get(w - stride2) >> 1) & 255;
						bgra.set(w++,cv1);
						bgra.set(w++,cv1);
						bgra.set(w++,cv1);
						ca1 = data.get(r++) + (ca1 + bgra.get(w - stride2) >> 1) & 255;
						bgra.set(w++,ca1);
					}
				} else {
					var _g37 = 0;
					var _g28 = width;
					while(_g37 < _g28) {
						var x7 = _g37++;
						cv1 = data.get(r++) + (cv1 + bgra.get(w - stride2) >> 1) & 255;
						bgra.set(w++,cv1);
						bgra.set(w++,cv1);
						bgra.set(w++,cv1);
						bgra.set(w++,cv1 == alphvaIdx ? 0 : 255);
					}
				}
				break;
			case 4:
				var stride3 = width * 4 * flipY1;
				var cv2 = 0;
				var ca2 = 0;
				if(alpha) {
					var _g38 = 0;
					var _g29 = width;
					while(_g38 < _g29) {
						var x8 = _g38++;
						cv2 = Tools.filter(bgra,x8,y,stride3,cv2,w) + data.get(r++) & 255;
						bgra.set(w++,cv2);
						bgra.set(w++,cv2);
						bgra.set(w++,cv2);
						ca2 = Tools.filter(bgra,x8,y,stride3,ca2,w) + data.get(r++) & 255;
						bgra.set(w++,ca2);
					}
				} else {
					var _g39 = 0;
					var _g210 = width;
					while(_g39 < _g210) {
						var x9 = _g39++;
						cv2 = Tools.filter(bgra,x9,y,stride3,cv2,w) + data.get(r++) & 255;
						bgra.set(w++,cv2);
						bgra.set(w++,cv2);
						bgra.set(w++,cv2);
						bgra.set(w++,cv2 == alphvaIdx ? 0 : 255);
					}
				}
				break;
			default:
				throw new (js__$Boot_HaxeError().default)("Invalid filter " + f);
			}
			w += lineDelta;
		}
		break;
	case 1:
		var alpha1 = _g[2];
		if(h.colbits != 8) {
			throw new (js__$Boot_HaxeError().default)("Unsupported color mode");
		}
		var width1 = h.width;
		var stride4 = (alpha1 ? 4 : 3) * width1 + 1;
		if(data.get_length() < h.height * stride4) {
			throw new (js__$Boot_HaxeError().default)("Not enough data");
		}
		var alphaRed = -1;
		var alphaGreen = -1;
		var alphaBlue = -1;
		if(!alpha1) {
			var t2 = d.iterator();
			while(t2.hasNext()) {
				var t3 = t2.next();
				if((Type().default).enumIndex(t3) == 4) {
					if(t3[2] == "tRNS") {
						var data2 = t3[3];
						if(data2.get_length() >= 6) {
							alphaRed = data2.get(1);
							alphaGreen = data2.get(3);
							alphaBlue = data2.get(5);
						}
						break;
					}
				}
			}
		}
		var cr = 0;
		var cg = 0;
		var cb = 0;
		var ca3 = 0;
		var _g11 = 0;
		var _g4 = h.height;
		while(_g11 < _g4) {
			var y1 = _g11++;
			var f1 = data.get(r++);
			switch(f1) {
			case 0:
				if(alpha1) {
					var _g310 = 0;
					var _g211 = width1;
					while(_g310 < _g211) {
						var x10 = _g310++;
						bgra.set(w++,data.get(r + 2));
						bgra.set(w++,data.get(r + 1));
						bgra.set(w++,data.get(r));
						bgra.set(w++,data.get(r + 3));
						r += 4;
					}
				} else {
					var _g311 = 0;
					var _g212 = width1;
					while(_g311 < _g212) {
						var x11 = _g311++;
						cb = data.get(r + 2);
						bgra.set(w++,cb);
						cg = data.get(r + 1);
						bgra.set(w++,cg);
						cr = data.get(r);
						bgra.set(w++,cr);
						bgra.set(w++,cr == alphaRed && cg == alphaGreen && cb == alphaBlue ? 0 : 255);
						r += 3;
					}
				}
				break;
			case 1:
				ca3 = 0;
				cb = ca3;
				cg = cb;
				cr = cg;
				if(alpha1) {
					var _g312 = 0;
					var _g213 = width1;
					while(_g312 < _g213) {
						var x12 = _g312++;
						cb += data.get(r + 2);
						bgra.set(w++,cb);
						cg += data.get(r + 1);
						bgra.set(w++,cg);
						cr += data.get(r);
						bgra.set(w++,cr);
						ca3 += data.get(r + 3);
						bgra.set(w++,ca3);
						r += 4;
					}
				} else {
					var _g313 = 0;
					var _g214 = width1;
					while(_g313 < _g214) {
						var x13 = _g313++;
						cb += data.get(r + 2);
						bgra.set(w++,cb);
						cg += data.get(r + 1);
						bgra.set(w++,cg);
						cr += data.get(r);
						bgra.set(w++,cr);
						bgra.set(w++,cr == alphaRed && cg == alphaGreen && cb == alphaBlue ? 0 : 255);
						r += 3;
					}
				}
				break;
			case 2:
				var stride5 = y1 == 0 ? 0 : width1 * 4 * flipY1;
				if(alpha1) {
					var _g314 = 0;
					var _g215 = width1;
					while(_g314 < _g215) {
						var x14 = _g314++;
						bgra.set(w,data.get(r + 2) + bgra.get(w - stride5));
						++w;
						bgra.set(w,data.get(r + 1) + bgra.get(w - stride5));
						++w;
						bgra.set(w,data.get(r) + bgra.get(w - stride5));
						++w;
						bgra.set(w,data.get(r + 3) + bgra.get(w - stride5));
						++w;
						r += 4;
					}
				} else {
					var _g315 = 0;
					var _g216 = width1;
					while(_g315 < _g216) {
						var x15 = _g315++;
						cb = data.get(r + 2) + bgra.get(w - stride5);
						bgra.set(w,cb);
						++w;
						cg = data.get(r + 1) + bgra.get(w - stride5);
						bgra.set(w,cg);
						++w;
						cr = data.get(r) + bgra.get(w - stride5);
						bgra.set(w,cr);
						++w;
						bgra.set(w++,cr == alphaRed && cg == alphaGreen && cb == alphaBlue ? 0 : 255);
						r += 3;
					}
				}
				break;
			case 3:
				ca3 = 0;
				cb = ca3;
				cg = cb;
				cr = cg;
				var stride6 = y1 == 0 ? 0 : width1 * 4 * flipY1;
				if(alpha1) {
					var _g316 = 0;
					var _g217 = width1;
					while(_g316 < _g217) {
						var x16 = _g316++;
						cb = data.get(r + 2) + (cb + bgra.get(w - stride6) >> 1) & 255;
						bgra.set(w++,cb);
						cg = data.get(r + 1) + (cg + bgra.get(w - stride6) >> 1) & 255;
						bgra.set(w++,cg);
						cr = data.get(r) + (cr + bgra.get(w - stride6) >> 1) & 255;
						bgra.set(w++,cr);
						ca3 = data.get(r + 3) + (ca3 + bgra.get(w - stride6) >> 1) & 255;
						bgra.set(w++,ca3);
						r += 4;
					}
				} else {
					var _g317 = 0;
					var _g218 = width1;
					while(_g317 < _g218) {
						var x17 = _g317++;
						cb = data.get(r + 2) + (cb + bgra.get(w - stride6) >> 1) & 255;
						bgra.set(w++,cb);
						cg = data.get(r + 1) + (cg + bgra.get(w - stride6) >> 1) & 255;
						bgra.set(w++,cg);
						cr = data.get(r) + (cr + bgra.get(w - stride6) >> 1) & 255;
						bgra.set(w++,cr);
						bgra.set(w++,cr == alphaRed && cg == alphaGreen && cb == alphaBlue ? 0 : 255);
						r += 3;
					}
				}
				break;
			case 4:
				var stride7 = width1 * 4 * flipY1;
				ca3 = 0;
				cb = ca3;
				cg = cb;
				cr = cg;
				if(alpha1) {
					var _g318 = 0;
					var _g219 = width1;
					while(_g318 < _g219) {
						var x18 = _g318++;
						cb = Tools.filter(bgra,x18,y1,stride7,cb,w) + data.get(r + 2) & 255;
						bgra.set(w++,cb);
						cg = Tools.filter(bgra,x18,y1,stride7,cg,w) + data.get(r + 1) & 255;
						bgra.set(w++,cg);
						cr = Tools.filter(bgra,x18,y1,stride7,cr,w) + data.get(r) & 255;
						bgra.set(w++,cr);
						ca3 = Tools.filter(bgra,x18,y1,stride7,ca3,w) + data.get(r + 3) & 255;
						bgra.set(w++,ca3);
						r += 4;
					}
				} else {
					var _g319 = 0;
					var _g220 = width1;
					while(_g319 < _g220) {
						var x19 = _g319++;
						cb = Tools.filter(bgra,x19,y1,stride7,cb,w) + data.get(r + 2) & 255;
						bgra.set(w++,cb);
						cg = Tools.filter(bgra,x19,y1,stride7,cg,w) + data.get(r + 1) & 255;
						bgra.set(w++,cg);
						cr = Tools.filter(bgra,x19,y1,stride7,cr,w) + data.get(r) & 255;
						bgra.set(w++,cr);
						bgra.set(w++,cr == alphaRed && cg == alphaGreen && cb == alphaBlue ? 0 : 255);
						r += 3;
					}
				}
				break;
			default:
				throw new (js__$Boot_HaxeError().default)("Invalid filter " + f1);
			}
			w += lineDelta;
		}
		break;
	case 2:
		var pal = Tools.getPalette(d);
		if(pal == null) {
			throw new (js__$Boot_HaxeError().default)("PNG Palette is missing");
		}
		var alpha2 = null;
		var t4 = d.iterator();
		while(t4.hasNext()) {
			var t5 = t4.next();
			if((Type().default).enumIndex(t5) == 4) {
				if(t5[2] == "tRNS") {
					var data3 = t5[3];
					alpha2 = data3;
					break;
				}
			}
		}
		if(alpha2 != null && alpha2.get_length() < 1 << h.colbits) {
			var alpha21 = (haxe_io_Bytes().default).alloc(1 << h.colbits);
			alpha21.blit(0,alpha2,0,alpha2.get_length());
			alpha21.fill(alpha2.get_length(),alpha21.get_length() - alpha2.get_length(),255);
			alpha2 = alpha21;
		}
		var width2 = h.width;
		var stride8 = Math.ceil(width2 * h.colbits / 8) + 1;
		if(data.get_length() < h.height * stride8) {
			throw new (js__$Boot_HaxeError().default)("Not enough data");
		}
		var tmp = h.width * h.colbits;
		var rline = tmp >> 3;
		var _g12 = 0;
		var _g5 = h.height;
		while(_g12 < _g5) {
			var y2 = _g12++;
			var f2 = data.get(r++);
			if(f2 == 0) {
				r += rline;
				continue;
			}
			switch(f2) {
			case 1:
				var c2 = 0;
				var _g320 = 0;
				var _g221 = width2;
				while(_g320 < _g221) {
					var x20 = _g320++;
					var v4 = data.get(r);
					c2 += v4;
					data.set(r++,c2 & 255);
				}
				break;
			case 2:
				var stride9 = y2 == 0 ? 0 : rline + 1;
				var _g321 = 0;
				var _g222 = width2;
				while(_g321 < _g222) {
					var x21 = _g321++;
					var v5 = data.get(r);
					data.set(r,v5 + data.get(r - stride9));
					++r;
				}
				break;
			case 3:
				var c3 = 0;
				var stride10 = y2 == 0 ? 0 : rline + 1;
				var _g322 = 0;
				var _g223 = width2;
				while(_g322 < _g223) {
					var x22 = _g322++;
					var v6 = data.get(r);
					c3 = v6 + (c3 + data.get(r - stride10) >> 1) & 255;
					data.set(r++,c3);
				}
				break;
			case 4:
				var stride11 = rline + 1;
				var c4 = 0;
				var _g323 = 0;
				var _g224 = width2;
				while(_g323 < _g224) {
					var x23 = _g323++;
					var v7 = data.get(r);
					c4 = Tools.filter(data,x23,y2,stride11,c4,r,1) + v7 & 255;
					data.set(r++,c4);
				}
				break;
			default:
				throw new (js__$Boot_HaxeError().default)("Invalid filter " + f2);
			}
		}
		var r1 = 0;
		if(h.colbits == 8) {
			var _g13 = 0;
			var _g6 = h.height;
			while(_g13 < _g6) {
				var y3 = _g13++;
				++r1;
				var _g324 = 0;
				var _g225 = h.width;
				while(_g324 < _g225) {
					var x24 = _g324++;
					var c5 = data.get(r1++);
					bgra.set(w++,pal.get(c5 * 3 + 2));
					bgra.set(w++,pal.get(c5 * 3 + 1));
					bgra.set(w++,pal.get(c5 * 3));
					bgra.set(w++,alpha2 != null ? alpha2.get(c5) : 255);
				}
				w += lineDelta;
			}
		} else if(h.colbits < 8) {
			var req = h.colbits;
			var mask = (1 << req) - 1;
			var _g14 = 0;
			var _g7 = h.height;
			while(_g14 < _g7) {
				var y4 = _g14++;
				++r1;
				var bits = 0;
				var nbits = 0;
				var v8;
				var _g325 = 0;
				var _g226 = h.width;
				while(_g325 < _g226) {
					var x25 = _g325++;
					if(nbits < req) {
						bits = bits << 8 | data.get(r1++);
						nbits += 8;
					}
					var c6 = bits >>> nbits - req & mask;
					nbits -= req;
					bgra.set(w++,pal.get(c6 * 3 + 2));
					bgra.set(w++,pal.get(c6 * 3 + 1));
					bgra.set(w++,pal.get(c6 * 3));
					bgra.set(w++,alpha2 != null ? alpha2.get(c6) : 255);
				}
				w += lineDelta;
			}
		} else {
			throw new (js__$Boot_HaxeError().default)(h.colbits + " indexed bits per pixel not supported");
		}
		break;
	}
	return bgra;
}
Tools.buildGrey = function(width,height,data,level) {
	if(level == null) {
		level = 9;
	}
	var rgb = (haxe_io_Bytes().default).alloc(width * height + height);
	var w = 0;
	var r = 0;
	var _g1 = 0;
	var _g = height;
	while(_g1 < _g) {
		var y = _g1++;
		rgb.set(w++,0);
		var _g3 = 0;
		var _g2 = width;
		while(_g3 < _g2) {
			var x = _g3++;
			rgb.set(w++,data.get(r++));
		}
	}
	var l = new (List().default)();
	l.add((format_png_Chunk().default).CHeader({ width : width, height : height, colbits : 8, color : (format_png_Color().default).ColGrey(false), interlaced : false}));
	l.add((format_png_Chunk().default).CData((format_tools_Deflate().default).run(rgb,level)));
	l.add((format_png_Chunk().default).CEnd);
	return l;
}
Tools.buildIndexed = function(width,height,data,palette,level) {
	if(level == null) {
		level = 9;
	}
	var rgb = (haxe_io_Bytes().default).alloc(width * height + height);
	var w = 0;
	var r = 0;
	var _g1 = 0;
	var _g = height;
	while(_g1 < _g) {
		var y = _g1++;
		rgb.set(w++,0);
		var _g3 = 0;
		var _g2 = width;
		while(_g3 < _g2) {
			var x = _g3++;
			rgb.set(w++,data.get(r++));
		}
	}
	var l = new (List().default)();
	l.add((format_png_Chunk().default).CHeader({ width : width, height : height, colbits : 8, color : (format_png_Color().default).ColIndexed, interlaced : false}));
	l.add((format_png_Chunk().default).CPalette(palette));
	l.add((format_png_Chunk().default).CData((format_tools_Deflate().default).run(rgb,level)));
	l.add((format_png_Chunk().default).CEnd);
	return l;
}
Tools.buildRGB = function(width,height,data,level) {
	if(level == null) {
		level = 9;
	}
	var rgb = (haxe_io_Bytes().default).alloc(width * height * 3 + height);
	var w = 0;
	var r = 0;
	var _g1 = 0;
	var _g = height;
	while(_g1 < _g) {
		var y = _g1++;
		rgb.set(w++,0);
		var _g3 = 0;
		var _g2 = width;
		while(_g3 < _g2) {
			var x = _g3++;
			rgb.set(w++,data.get(r + 2));
			rgb.set(w++,data.get(r + 1));
			rgb.set(w++,data.get(r));
			r += 3;
		}
	}
	var l = new (List().default)();
	l.add((format_png_Chunk().default).CHeader({ width : width, height : height, colbits : 8, color : (format_png_Color().default).ColTrue(false), interlaced : false}));
	l.add((format_png_Chunk().default).CData((format_tools_Deflate().default).run(rgb,level)));
	l.add((format_png_Chunk().default).CEnd);
	return l;
}
Tools.build32ARGB = function(width,height,data,level) {
	if(level == null) {
		level = 9;
	}
	var rgba = (haxe_io_Bytes().default).alloc(width * height * 4 + height);
	var w = 0;
	var r = 0;
	var _g1 = 0;
	var _g = height;
	while(_g1 < _g) {
		var y = _g1++;
		rgba.set(w++,0);
		var _g3 = 0;
		var _g2 = width;
		while(_g3 < _g2) {
			var x = _g3++;
			rgba.set(w++,data.get(r + 1));
			rgba.set(w++,data.get(r + 2));
			rgba.set(w++,data.get(r + 3));
			rgba.set(w++,data.get(r));
			r += 4;
		}
	}
	var l = new (List().default)();
	l.add((format_png_Chunk().default).CHeader({ width : width, height : height, colbits : 8, color : (format_png_Color().default).ColTrue(true), interlaced : false}));
	l.add((format_png_Chunk().default).CData((format_tools_Deflate().default).run(rgba,level)));
	l.add((format_png_Chunk().default).CEnd);
	return l;
}
Tools.build32BGRA = function(width,height,data,level) {
	if(level == null) {
		level = 9;
	}
	var rgba = (haxe_io_Bytes().default).alloc(width * height * 4 + height);
	var w = 0;
	var r = 0;
	var _g1 = 0;
	var _g = height;
	while(_g1 < _g) {
		var y = _g1++;
		rgba.set(w++,0);
		var _g3 = 0;
		var _g2 = width;
		while(_g3 < _g2) {
			var x = _g3++;
			rgba.set(w++,data.get(r + 2));
			rgba.set(w++,data.get(r + 1));
			rgba.set(w++,data.get(r));
			rgba.set(w++,data.get(r + 3));
			r += 4;
		}
	}
	var l = new (List().default)();
	l.add((format_png_Chunk().default).CHeader({ width : width, height : height, colbits : 8, color : (format_png_Color().default).ColTrue(true), interlaced : false}));
	l.add((format_png_Chunk().default).CData((format_tools_Deflate().default).run(rgba,level)));
	l.add((format_png_Chunk().default).CEnd);
	return l;
}


// Export

exports.default = Tools;