// Class: format.png.Writer

var $global = typeof window != "undefined" ? window : typeof global != "undefined" ? global : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = require("./../../hxClasses_stub").default;
var $import = require("./../../import_stub").default;
function Type() {return require("./../../Type");}
function haxe_io_Bytes() {return require("./../../haxe/io/Bytes");}
function haxe_io_BytesOutput() {return require("./../../haxe/io/BytesOutput");}
function haxe_crypto_Crc32() {return require("./../../haxe/crypto/Crc32");}
function HxOverrides() {return require("./../../HxOverrides");}

// Constructor

var Writer = function(o) {
	this.o = o;
	o.set_bigEndian(true);
}

// Meta

Writer.__name__ = ["format","png","Writer"];
Writer.prototype = {
	write: function(png) {
		var _g = 0;
		var _g1 = [137,80,78,71,13,10,26,10];
		while(_g < _g1.length) {
			var b = _g1[_g];
			++_g;
			this.o.writeByte(b);
		}
		var c = png.iterator();
		while(c.hasNext()) {
			var c1 = c.next();
			switch((Type().default).enumIndex(c1)) {
			case 0:
				this.writeChunk("IEND",(haxe_io_Bytes().default).alloc(0));
				break;
			case 1:
				var h = c1[2];
				var b1 = new (haxe_io_BytesOutput().default)();
				b1.set_bigEndian(true);
				b1.writeInt32(h.width);
				b1.writeInt32(h.height);
				b1.writeByte(h.colbits);
				var _g2 = h.color;
				var tmp;
				switch((Type().default).enumIndex(_g2)) {
				case 0:
					var alpha = _g2[2];
					if(alpha) {
						tmp = 4;
					} else {
						tmp = 0;
					}
					break;
				case 1:
					var alpha1 = _g2[2];
					if(alpha1) {
						tmp = 6;
					} else {
						tmp = 2;
					}
					break;
				case 2:
					tmp = 3;
					break;
				}
				b1.writeByte(tmp);
				b1.writeByte(0);
				b1.writeByte(0);
				b1.writeByte(h.interlaced ? 1 : 0);
				this.writeChunk("IHDR",b1.getBytes());
				break;
			case 2:
				var d = c1[2];
				this.writeChunk("IDAT",d);
				break;
			case 3:
				var b2 = c1[2];
				this.writeChunk("PLTE",b2);
				break;
			case 4:
				var data = c1[3];
				var id = c1[2];
				this.writeChunk(id,data);
				break;
			}
		}
	},
	writeChunk: function(id,data) {
		this.o.writeInt32(data.get_length());
		this.o.writeString(id);
		this.o.write(data);
		var crc = new (haxe_crypto_Crc32().default)();
		var _g = 0;
		while(_g < 4) {
			var i = _g++;
			crc["byte"]((HxOverrides().default).cca(id,i));
		}
		crc.update(data,0,data.get_length());
		this.o.writeInt32(crc.get());
	}
};
Writer.prototype.__class__ = Writer.prototype.constructor = $hxClasses["format.png.Writer"] = Writer;

// Init



// Statics




// Export

exports.default = Writer;