// Class: openfl._internal.utils.MouseEventPool

var $global = typeof window != "undefined" ? window : typeof global != "undefined" ? global : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = require("./../../../hxClasses_stub").default;
var $import = require("./../../../import_stub").default;
function haxe_ds_ObjectMap() {return require("./../../../haxe/ds/ObjectMap");}
function openfl_events_MouseEvent() {return require("./../../../openfl/events/MouseEvent");}
function List() {return require("./../../../List");}

// Constructor

var MouseEventPool = function(size) {
	this.__pool = new (haxe_ds_ObjectMap().default)();
	this.activeObjects = 0;
	this.inactiveObjects = 0;
	this.__inactiveObject0 = null;
	this.__inactiveObject1 = null;
	this.__inactiveObjectList = new (List().default)();
	if(size != null) {
		this.set_size(size);
	}
}

// Meta

MouseEventPool.__name__ = ["openfl","_internal","utils","MouseEventPool"];
MouseEventPool.prototype = {
	add: function(object) {
		if(!this.__pool.exists(object)) {
			this.__pool.set(object,false);
			this.clean(object);
			this.__addInactive(object);
		}
	},
	clean: function(object) {
		object.__isCanceled = false;
		object.__isCanceledNow = false;
		object.__preventDefault = false;
		object.eventPhase = 2;
	},
	clear: function() {
		this.__pool = new (haxe_ds_ObjectMap().default)();
		this.activeObjects = 0;
		this.inactiveObjects = 0;
		this.__inactiveObject0 = null;
		this.__inactiveObject1 = null;
		this.__inactiveObjectList.clear();
	},
	create: function(type,stageX,stageY,local,target,delta) {
		if(delta == null) {
			delta = 0;
		}
		var event = new (openfl_events_MouseEvent().default)(type,true,false,null != local ? local.x : 0,null != local ? local.y : 0,null,(openfl_events_MouseEvent().default).__ctrlKey,(openfl_events_MouseEvent().default).__altKey,(openfl_events_MouseEvent().default).__shiftKey,(openfl_events_MouseEvent().default).__buttonDown,delta,(openfl_events_MouseEvent().default).__commandKey);
		event.stageX = stageX;
		event.stageY = stageY;
		event.target = target;
		return event;
	},
	get: function(type,stageX,stageY,local,target) {
		var object = null;
		if(this.inactiveObjects > 0) {
			object = this.__getInactive();
			object.type = type;
			object.bubbles = true;
			object.cancelable = false;
			object.localX = local.x;
			object.localY = local.y;
			object.stageX = stageX;
			object.stageY = stageY;
			object.target = target;
		} else if(this.__size == null || this.activeObjects < this.__size) {
			object = this.create(type,stageX,stageY,local,target);
			if(object != null) {
				this.__pool.set(object,true);
				this.activeObjects++;
			}
		}
		return object;
	},
	release: function(object) {
		this.activeObjects--;
		if(this.__size == null || this.activeObjects + this.inactiveObjects < this.__size) {
			this.clean(object);
			this.__addInactive(object);
		} else {
			this.__pool.remove(object);
		}
	},
	__addInactive: function(object) {
		if(this.__inactiveObject0 == null) {
			this.__inactiveObject0 = object;
		} else if(this.__inactiveObject1 == null) {
			this.__inactiveObject1 = object;
		} else {
			this.__inactiveObjectList.add(object);
		}
		this.inactiveObjects++;
	},
	__getInactive: function() {
		var object = null;
		if(this.__inactiveObject0 != null) {
			object = this.__inactiveObject0;
			this.__inactiveObject0 = null;
		} else if(this.__inactiveObject1 != null) {
			object = this.__inactiveObject1;
			this.__inactiveObject1 = null;
		} else {
			object = this.__inactiveObjectList.pop();
			if(this.__inactiveObjectList.length > 0) {
				this.__inactiveObject0 = this.__inactiveObjectList.pop();
			}
			if(this.__inactiveObjectList.length > 0) {
				this.__inactiveObject1 = this.__inactiveObjectList.pop();
			}
		}
		this.inactiveObjects--;
		this.activeObjects++;
		return object;
	},
	__removeInactive: function(count) {
		if(count <= 0 || this.inactiveObjects == 0) {
			return;
		}
		if(this.__inactiveObject0 != null) {
			this.__pool.remove(this.__inactiveObject0);
			this.__inactiveObject0 = null;
			this.inactiveObjects--;
			--count;
		}
		if(count == 0 || this.inactiveObjects == 0) {
			return;
		}
		if(this.__inactiveObject1 != null) {
			this.__pool.remove(this.__inactiveObject1);
			this.__inactiveObject1 = null;
			this.inactiveObjects--;
			--count;
		}
		if(count == 0 || this.inactiveObjects == 0) {
			return;
		}
		var object = this.__inactiveObjectList.iterator();
		while(object.hasNext()) {
			var object1 = object.next();
			this.__pool.remove(object1);
			this.__inactiveObjectList.remove(object1);
			this.inactiveObjects--;
			--count;
			if(count == 0 || this.inactiveObjects == 0) {
				return;
			}
		}
	},
	get_size: function() {
		return this.__size;
	},
	set_size: function(value) {
		if(value == null) {
			this.__size = null;
		} else {
			var current = this.inactiveObjects + this.activeObjects;
			this.__size = value;
			if(current > value) {
				this.__removeInactive(current - value);
			} else if(value > current) {
				var object;
				var _g1 = 0;
				var _g = value - current;
				while(_g1 < _g) {
					var i = _g1++;
					object = this.create("click",0,0,null,null);
					if(object != null) {
						this.__pool.set(object,false);
						this.__inactiveObjectList.add(object);
						this.inactiveObjects++;
					} else {
						break;
					}
				}
			}
		}
		return value;
	}
};
MouseEventPool.prototype.__class__ = MouseEventPool.prototype.constructor = $hxClasses["openfl._internal.utils.MouseEventPool"] = MouseEventPool;

// Init



// Statics


MouseEventPool.__meta__ = { obj : { SuppressWarnings : ["checkstyle:FieldDocComment"]}}

// Export

exports.default = MouseEventPool;