package flash.display {
	
	
	/**
	 * @externs
	 * The SpreadMethod class provides values for the `spreadMethod`
	 * parameter in the `beginGradientFill()` and
	 * `lineGradientStyle()` methods of the Graphics class.
	 *
	 * The following example shows the same gradient fill using various spread
	 * methods:
	 */
	public class SpreadMethod {
		
		/**
		 * Specifies that the gradient use the _pad_ spread method.
		 */
		public static const PAD:String = "pad";
		
		/**
		 * Specifies that the gradient use the _reflect_ spread method.
		 */
		public static const REFLECT:String = "reflect";
		
		/**
		 * Specifies that the gradient use the _repeat_ spread method.
		 */
		public static const REPEAT:String = "repeat";
		
	}
	
	
}