package flash.text {
	
	
	/**
	 * @externs
	 * The TextFormatAlign class provides values for text alignment in the
	 * TextFormat class.
	 */
	final public class TextFormatAlign {
		
		/**
		 * Constant; centers the text in the text field. Use the syntax
		 * `TextFormatAlign.CENTER`.
		 */
		public static const CENTER:String = "center";
		
		public static const END:String = "end";
		
		/**
		 * Constant; justifies text within the text field. Use the syntax
		 * `TextFormatAlign.JUSTIFY`.
		 */
		public static const JUSTIFY:String = "justify";
		
		/**
		 * Constant; aligns text to the left within the text field. Use the syntax
		 * `TextFormatAlign.LEFT`.
		 */
		public static const LEFT:String = "left";
		
		/**
		 * Constant; aligns text to the right within the text field. Use the syntax
		 * `TextFormatAlign.RIGHT`.
		 */
		public static const RIGHT:String = "right";
		
		public static const START:String = "start";
		
	}
	
	
}