package openfl.display {
	
	
	/**
	* @externs
	* The CapsStyle class is an enumeration of constant values that specify the
	* caps style to use in drawing lines. The constants are provided for use as
	* values in the `caps` parameter of the
	* `openfl.display.Graphics.lineStyle()` method. You can specify the
	* following three types of caps:
	*/
	final public class CapsStyle {
		
		/**
		* Used to specify no caps in the `caps` parameter of the
		* `openfl.display.Graphics.lineStyle()` method.
		*/
		public static const NONE:String = "none";
		
		/**
		* Used to specify round caps in the `caps` parameter of the
		* `openfl.display.Graphics.lineStyle()` method.
		*/
		public static const ROUND:String = "round";
		
		/**
		* Used to specify square caps in the `caps` parameter of the
		* `openfl.display.Graphics.lineStyle()` method.
		*/
		public static const SQUARE:String = "square";
		
	}
	
	
}