declare namespace openfl.display {
	
	/**
	 * The StageAlign class provides constant values to use for the
	 * `Stage.align` property.
	 */
	export enum StageAlign {
		
		/**
		 * Specifies that the Stage is aligned at the bottom.
		 */
		BOTTOM = "bottom",
		
		/**
		 * Specifies that the Stage is aligned on the left.
		 */
		BOTTOM_LEFT = "bottomLeft",
		
		/**
		 * Specifies that the Stage is aligned to the right.
		 */
		BOTTOM_RIGHT = "bottomRight",
		
		/**
		 * Specifies that the Stage is aligned on the left.
		 */
		LEFT = "left",
		
		/**
		 * Specifies that the Stage is aligned to the right.
		 */
		RIGHT = "right",
		
		/**
		 * Specifies that the Stage is aligned at the top.
		 */
		TOP = "top",
		
		/**
		 * Specifies that the Stage is aligned on the left.
		 */
		TOP_LEFT = "topLeft",
		
		/**
		 * Specifies that the Stage is aligned to the right.
		 */
		TOP_RIGHT = "topRight",
		
	}
	
}


export default openfl.display.StageAlign;