package openfl.display;

/**
 * The StageAlign class provides constant values to use for the
 * `Stage.align` property.
 */
@:enum abstract StageAlign(String) from String to String
{
	/**
	 * Specifies that the Stage is aligned at the bottom.
	 */
	public var BOTTOM = "bottom";

	/**
	 * Specifies that the Stage is aligned on the left.
	 */
	public var BOTTOM_LEFT = "bottomLeft";

	/**
	 * Specifies that the Stage is aligned to the right.
	 */
	public var BOTTOM_RIGHT = "bottomRight";

	/**
	 * Specifies that the Stage is aligned on the left.
	 */
	public var LEFT = "left";

	/**
	 * Specifies that the Stage is aligned to the right.
	 */
	public var RIGHT = "right";

	/**
	 * Specifies that the Stage is aligned at the top.
	 */
	public var TOP = "top";

	/**
	 * Specifies that the Stage is aligned on the left.
	 */
	public var TOP_LEFT = "topLeft";

	/**
	 * Specifies that the Stage is aligned to the right.
	 */
	public var TOP_RIGHT = "topRight";
}
